#include<iostream>
#include<string>
#include<algorithm>
#include<vector>
using namespace std;


struct Node {
	int next[30];
	int val;
	
	Node() {
		fill(next, next+30, -1);
		val = -1;
	}
};


struct Trie {
	vector<Node> nodes;
	
	Trie() {
		nodes.resize(1);
	}
	
	
	void addStringDFS(string &str, int valToSet, size_t sind = 0, size_t nodeInd = 0) {
		if(sind == str.size() ) {
			nodes[nodeInd].val = valToSet;
			return;
		}
		
		int cind = str[sind] - 'a';
		if(nodes[nodeInd].next[cind] == -1) {
			nodes[nodeInd].next[cind] = nodes.size();
			nodes.resize(nodes.size()+1);
		}
		
		addStringDFS(str, valToSet, sind+1, nodes[nodeInd].next[cind]);
	}
	
	int getVal(string &str, size_t sind = 0, size_t nodeInd = 0) {
		if(sind == str.size() )
			return nodes[nodeInd].val;
		
		int cind = str[sind] - 'a';
		if(nodes[nodeInd].next[cind] == -1)
			return -1;
		
		return getVal(str, sind+1, nodes[nodeInd].next[cind]);
	}
}trie;





int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	int n, m, p1;
	string s;
	cin >> n;
	
	for(int i=0;i<n;i++) {
		cin >> p1 >> s;
		
		trie.addStringDFS(s, i+1);
	}
	
	cin >> m;
	
	for(int i=0;i<m;i++) {
		cin >> p1 >> s;
		cout << trie.getVal(s) << '\n';
	}
	
	return 0;
}
































