#include<iostream>
#include<string>
#include<algorithm>
#include<vector>
using namespace std;

int n, m, l[100000], appears[100000];


string a, b[100000];



struct node{
	int transfer, numapp;
	
	int next[26];
	bool terminal;
	int previous, parent;
	
	vector<int> terminal_inds;
	vector<int> owns;
	
	node() {
		for(int i=0;i<26;i++)
			next[i] = -1;
		
		terminal = false;
		previous = -1;
		parent = -1;
		
		numapp = 0;
	}
};




struct ahotree {
	vector<node> nodes;
	
	
	ahotree() {
		nodes.push_back(node());
	}
	
	
	//Add a string to the list of strings the tree accepts
	
	void addstr(string s, int terminal_ind) {
		
		int spos = 0;
		int cind = 0;
		
		while(spos < (int)s.size() ) {
			int charind = s[spos] - 'a', nextind;
			
			if(nodes[cind].next[charind] == -1) {
			
				nodes.push_back(node());
				nodes[cind].next[charind] = nodes.size() - 1;
				
				nextind = nodes.size() - 1;
				
				nodes[nextind].transfer = charind;
				
				nodes[nextind].parent = cind;
			}
			
			cind = nodes[cind].next[charind];
			
			spos++;
		}
		
		nodes[cind].terminal = true;
		nodes[cind].terminal_inds.push_back(terminal_ind);
		
	}
	
	
	
	
	//Initialize the previous links
	
	void initialize() {
		int cind = 0;
		
		vector<int> front;
		
		for(int i=0;i<26;i++)
			if(nodes[cind].next[i] != -1) {
				nodes[nodes[cind].next[i]].previous = cind;
				
				nodes[cind].owns.push_back(nodes[cind].next[i]);
				
				front.push_back(nodes[cind].next[i]);
			}
		
		
		
		for(int frind = 0; frind < (int)front.size();frind++) {
			cind = front[frind];
			
			
			for(int i=0;i<26;i++)
				if(nodes[cind].next[i] != -1) {
				
					int nextind = nodes[cind].next[i];
					
					nodes[nextind].previous = nodes[cind].previous;
					
					
					//Here we try to find the previous substring
					
					while(nodes[nextind].previous != -1 && nodes[nodes[nextind].previous].next[i] == -1)
						nodes[nextind].previous = nodes[nodes[nextind].previous].previous;
					
					
					if(nodes[nextind].previous != -1)
						nodes[nextind].previous = nodes[nodes[nextind].previous].next[i];
					else
						nodes[nextind].previous = 0;
					
					nodes[nodes[nextind].previous].owns.push_back(nextind);
					
					front.push_back(nextind);
				}
				
		}
		
	}
	
	
	
	//Auxilliary function to add together the nodes of children
	
	void output(int cind) {
		for(int i=0;i< (int)nodes[cind].owns.size();i++) {
			output(nodes[cind].owns[i]);
			
			nodes[cind].numapp += nodes[nodes[cind].owns[i]].numapp;
		}
		
		for(int i=0;i<(int)nodes[cind].terminal_inds.size();i++)
			appears[nodes[cind].terminal_inds[i]] += nodes[cind].numapp;
	}
	
	//Check no. of occourences 
	
	void check(string s) {
		int cind = 0;
		
		
		for(int i=0;i<(int)s.size();i++) {
			int charind = s[i] - 'a';
			
			
			while(cind != -1 && nodes[cind].next[charind] == -1)
				cind = nodes[cind].previous;
			
			
			if(cind != -1)
				cind = nodes[cind].next[charind];
			else
				cind = 0;
			
			
			nodes[cind].numapp++;
		}
		
	}
	
};






//--------------------------------------------------------
//Main algorithm begins here


ahotree atree;

int main() {
	cin.sync_with_stdio(false);
	
	cin >> n >> m >> a;
	
	for(int i=0;i<m;i++) {
		cin >> l[i] >> b[i];
		
		atree.addstr(b[i], i);
	}
	
	atree.initialize();
	
	atree.check(a);
	atree.output(0);
	
	
	for(int i=0;i<m;i++)
		cout << appears[i] << '\n';
		
	
	return 0;
}































